#include <bits/stdc++.h>
using namespace std;

int main()
{
   long long  int x,  xpoc;
  long long int t, n, m;
  cin >> t;
  int resenje[t];

  int k, r, res = 0;
  for(int i = 0; i < t;i++){
    cin >> n >> m;
   long long int  a[n];
    long long int b[m];
for(int j = 0; j < n; j++){
    cin >> k;
    a[j] = k;}
  sort(a, a + n);
    xpoc = a[1] - a[0];
  for(int o = 1;o < n;o++){
    x = a[o] - a[o-1];
    if(xpoc >= x) xpoc = x;}

    for(int h = 1;h < n;h++){

    if(0 == (a[h] - a[0]) % xpoc) res = 1;}

  for(int p = 0; p < m;p++){
    cin >> r;
    b[p] = r;

    if((b[p] - a[0]) % xpoc == 0) res = 0;
    } resenje[i] = res;}


    for(int i = 0; i < t;i++)
    cout << resenje[i] << endl;
    return 0;
}